package com.glxp.udidl.admin.service.tyapi;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.glxp.udidl.admin.res.tyapi.SupplierResponse;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.glxp.udidl.admin.entity.tyapi.TySupplierEntity;
import com.glxp.udidl.admin.dao.tyapi.TySupplierMapper;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
public class TySupplierService extends ServiceImpl<TySupplierMapper, TySupplierEntity> {
    @Resource
    TyDlHttpClient tyDlHttpClient;
    @Resource
    TySupplierMapper tySupplierMapper;

    public void download(String hospital) {

        Integer pageNum = 1;
        Integer pageSize = 20;
        while (true) {
            SupplierResponse supplierResponse = tyDlHttpClient.getSupplier(hospital, pageNum, pageSize);
            if (supplierResponse.getErrorCode() == 0) {
                List<SupplierResponse.ResultDTO.PageBeanDTO.SupplierDTO> supplierDTOS = supplierResponse.getResult().getPageBean().getResult();
                List<TySupplierEntity> tySupplierEntities = BeanUtil.copyToList(supplierDTOS, TySupplierEntity.class);
                if (CollUtil.isNotEmpty(supplierDTOS)) {
                    for (TySupplierEntity tySupplierEntity : tySupplierEntities) {
                        tySupplierEntity.setHospName(hospital);
                        tySupplierEntity.setUpdateTime(new Date());
                    }
                }
                tySupplierMapper.insertBatch(tySupplierEntities);
                if (CollUtil.isNotEmpty(supplierDTOS) && supplierDTOS.size() == 20) {
                    pageNum = pageNum + 1;
                } else {
                    return;
                }
            }
        }
    }


}
